﻿using System;
using Xamarin.Forms;

namespace TestProject
{
    /// <summary>
    /// 메인 페이지
    /// </summary>
    public partial class MainPage : ContentPage
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 번역 번호
        /// </summary>
        private string translateNumber;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - MainPage()

        /// <summary>
        /// 생성자
        /// </summary>
        public MainPage()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 번역하기 버튼 클릭시 처리하기 - translateButon_Clicked(sender, e)

        /// <summary>
        /// 번역하기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void translateButon_Clicked(object sender, EventArgs e)
        {
            this.translateNumber = PhoneHelper.GetPhoneNumber(this.phoneNumberText.Text);

            if(!string.IsNullOrWhiteSpace(this.translateNumber))
            {
                this.callButton.IsEnabled = true;
                this.callButton.Text      = translateNumber + " 전화걸기";
            }
            else
            {
                this.callButton.IsEnabled = false;
                this.callButton.Text      = "전화걸기";
            }
        }

        #endregion
        #region 전화걸기 버튼 클릭시 처리하기 - callButton_Clicked(sender, e)

        /// <summary>
        /// 전화걸기 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private async void callButton_Clicked(object sender, EventArgs e)
        {
            bool result = await this.DisplayAlert
            (
                "전화걸기",
                string.Format("{0} 번호로 전화를 걸으시겠습니까?", this.translateNumber),
                "예",
                "아니오"
            );

            if(result)
            {
                IDialer dialer = DependencyService.Get<IDialer>();

                if(dialer != null)
                {
                    dialer.Dial(this.translateNumber);
                }
            }
        }

        #endregion
    }
}